


#include "h/Affichages.h"
#include "h/Parametres.h"



unsigned char g_Affichages[8] = {0x00};

unsigned char g_LimiteActualisations = 255;



const rom unsigned char ValeursPORTA[8] = {0x00, 0x00, 0x00, 0x00, 0x08, 0x04, 0x02, 0x01};

const rom unsigned char ValeursPORTB[8] = {0x10, 0x20, 0x40, 0x80, 0x00, 0x00, 0x00, 0x00};



const rom unsigned char ArrondisValeursPositives[16] = {0, 1, 1, 2, 3, 3, 4, 4, 5, 6, 6, 7, 8, 8, 9, 9};

const rom unsigned char ArrondisValeursNegatives[16] = {9, 9, 8, 8, 7, 7, 6, 6, 5, 4, 4, 3, 2, 2, 1, 0};



unsigned char ConvertirPourAffichage(unsigned char Valeur)
{
	switch(Valeur)
	{
		case '0' :
			{
				return 0x7B;
				break;
			}
		case '1' :
			{
				return 0x60;
				break;
			}
		case '2' :
			{
				return 0x37;
				break;
			}
		case '3' :
			{
				return 0x75;
				break;
			}
		case '4' :
			{
				return 0x6C;
				break;
			}
		case '5' :
			{
				return 0x5D;
				break;
			}
		case '6' :
			{
				return 0x5F;
				break;
			}
		case '7' :
			{
				return 0x70;
				break;
			}
		case '8' :
			{
				return 0x7F;
				break;
			}
		case '9' :
			{
				return 0x7D;
				break;
			}
		case '-' :
			{
				return 0x04;
				break;
			}
		case ' ' :
			{
				return 0x00;
				break;
			}
		case 'p' :
			{
				return 0x3E;
				break;
			}
		case 'r' :
			{
				return 0x06;
				break;
			}
		case 't' :
			{
				return 0x0F;
				break;
			}
		case 'A' :
			{
				return 0x7E;
				break;
			}
		case 'C' :
			{
				return 0x1B;
				break;
			}
		case 'E' :
			{
				return 0x1F;
				break;
			}
		case 'S' :
			{
				return 0x5D;
				break;
			}
		case '' :
		{
			return 0x3C;
			break;
		}
		default :
		{
			return 0x00;
			break;
		}
	}
}

void AfficherUneTemperature(unsigned char Endroit, unsigned char L1, unsigned char L2)
{
	unsigned char Choix = 0;

	Choix = ((Endroit - 1) * 4);

			if(L1 < 0x80)
			{
				if(L1 <= 99)
				{
					g_Affichages[Choix] = 0x00;
				}
				else
				{
					g_Affichages[Choix] = ConvertirPourAffichage(0x30 + (L1 / 100));
				}

				if(L1 <= 9)
				{
					g_Affichages[(Choix + 1)] = 0x00;
				}
				else
				{
					g_Affichages[(Choix + 1)] = ConvertirPourAffichage(0x30 + ((L1 - ((L1 / 100) * 100)) / 10));
				}

				g_Affichages[(Choix + 2)] = (MASQUAGE_AFFICHAGE_VIRGULE | ConvertirPourAffichage(0x30 + (L1 % 10)));
		
				g_Affichages[(Choix + 3)] = ConvertirPourAffichage(0x30 + ((ArrondisValeursPositives[(L2 >> 4)])));

			}
			else
			{
				L1 = (127 - (0x7F & L1));

				if(L1 <= 9)
				{
					g_Affichages[Choix] = 0x00;
					g_Affichages[(Choix + 1)] = ConvertirPourAffichage('-');
				}
				else
				{
					g_Affichages[Choix] = ConvertirPourAffichage('-');
					g_Affichages[(Choix + 1)] = ConvertirPourAffichage(0x30 + (L1 / 10));
				}

				g_Affichages[(Choix + 2)] = (MASQUAGE_AFFICHAGE_VIRGULE | ConvertirPourAffichage(0x30 + (L1 % 10)));
		
				g_Affichages[(Choix + 3)] = ConvertirPourAffichage(0x30 + ((ArrondisValeursNegatives[(L2 >> 4)])));

			}
}

void AfficherValeurComptage(int Valeur)
{
	int k = 0;

	unsigned char Tampon[4];

	if(Valeur <= 999)
	{
		g_Affichages[4] = 0x00;
	}
	if(Valeur <= 99)
	{
		g_Affichages[5] = 0x00;
	}
	if(Valeur <= 9)
	{
		g_Affichages[6] = 0x00;
	}

	/* Remplissage de  Tampon  par la combinaison d'affichage du rsultat de l'opration (Nombre % Base). */
	do
	{
		Tampon[k] = ConvertirPourAffichage(0x30 + (Valeur % 10));    /* Conversion Dcimale / Combinaison d'affichage de la fin de la chane de caractres vers le dbut. */
		Valeur = (Valeur / 10);
		k++;
	}
	while(Valeur > 0);   			

	/* Affichage le contenu de  Tampon , de la fin vers le dbut et caractre par caractre, directement sur les afficheurs  7 segments. */
	do
	{
		k--;
		g_Affichages[(7 - k)] = Tampon[k];	
	}
	while(k > 0);

}



