


#include <p18f4550.h>

#include "h/MemorisationsEEPROM.h"
#include "h/Utilitaires.h"
#include "h/Parametres.h"



unsigned char EERead(unsigned char ad)
{
	EECON1bits.EEPGD = 0;
	EECON1bits.CFGS = 0;
	EEADR = ad;
	EECON1bits.RD = 1;

	return EEDATA;
}

unsigned char EEWrite(unsigned char ad, unsigned char val)
{
	EEADR = ad;
	EEDATA = val;
	EECON1bits.EEPGD = 0;
	EECON1bits.CFGS = 0;
	EECON1bits.WREN = 1;
	INTCONbits.GIE = 0;
	EECON2 = 0x55;
	EECON2 = 0xAA;
	EECON1bits.WR = 1;
	INTCONbits.GIE = 1;
	while(EECON1bits.WR);
	EECON1bits.WREN = 0;
}

unsigned char AttribuerUneFonction(unsigned char Precedente)
{
	unsigned char Fonction = THERMOMETRE;

		if(Precedente == THERMOMETRE)
		{
			if((BOUTONS_POUSSOIRS_INFORMATIONS == 1) && (BOUTON_POUSSOIR_MAXIMA_MINIMA == 0) && (BOUTON_POUSSOIR_REINITIALISATIONS == 0))
			{
				EEWrite(ADRESSE_FONCTIONNEMENT, COMPTEUR);
				Fonction = COMPTEUR;
			}
			else
			{
				Fonction = THERMOMETRE;
			}
		}
		else
		{
			if(Precedente == COMPTEUR)
			{
				if((BOUTONS_POUSSOIRS_INFORMATIONS == 1) && (BOUTON_POUSSOIR_MAXIMA_MINIMA == 0) && (BOUTON_POUSSOIR_REINITIALISATIONS == 0))
				{
					EEWrite(ADRESSE_FONCTIONNEMENT, THERMOMETRE);
					Fonction = THERMOMETRE;
				}
				else
				{
					Fonction = COMPTEUR;
				}
			}
		}

	return Fonction;
}

void RecupererExtremes1(int * Minimale1, int * Maximale1)
{
	unsigned char L0;
	unsigned char L1;

	L1 = EERead(ADRESSE_MINIMUM_1);
	L0 = EERead(ADRESSE_MINIMUM_1 + 1);

	* Minimale1 = OctetsVersEntier(L1, L0);

	L1 = EERead(ADRESSE_MAXIMUM_1);
	L0 = EERead(ADRESSE_MAXIMUM_1 + 1);

	* Maximale1 = OctetsVersEntier(L1, L0);
}

void RecupererExtremes2(int * Minimale2, int * Maximale2)
{
	unsigned char L0;
	unsigned char L1;

	L1 = EERead(ADRESSE_MINIMUM_2);
	L0 = EERead(ADRESSE_MINIMUM_2 + 1);

	* Minimale2 = OctetsVersEntier(L1, L0);

	L1 = EERead(ADRESSE_MAXIMUM_2);
	L0 = EERead(ADRESSE_MAXIMUM_2 + 1);

	* Maximale2 = OctetsVersEntier(L1, L0);
}


void EnregistrerExtremes1(int Minimum1, int Maximum1)
{
	unsigned char L0;
	unsigned char L1;

	EntierVersOctets(Minimum1, &L1, &L0);

	EEWrite(ADRESSE_MINIMUM_1, L1);
	EEWrite((ADRESSE_MINIMUM_1 + 1), L0);

	EntierVersOctets(Maximum1, &L1, &L0);

	EEWrite(ADRESSE_MAXIMUM_1, L1);
	EEWrite((ADRESSE_MAXIMUM_1 + 1), L0);
}

void EnregistrerExtremes2(int Minimum2, int Maximum2)
{
	unsigned char L0;
	unsigned char L1;

	EntierVersOctets(Minimum2, &L1, &L0);

	EEWrite(ADRESSE_MINIMUM_2, L1);
	EEWrite((ADRESSE_MINIMUM_2 + 1), L0);

	EntierVersOctets(Maximum2, &L1, &L0);

	EEWrite(ADRESSE_MAXIMUM_2, L1);
	EEWrite((ADRESSE_MAXIMUM_2 + 1), L0);
}

void EnregistrerValeurComptage(int Information)
{
	unsigned char L0;
	unsigned char L1;
	
	EntierVersOctets(Information, &L1, &L0);

	EEWrite(ADRESSE_COMPTAGE, L1);
	EEWrite((ADRESSE_COMPTAGE + 1), L0);
}

int RecupererValeurComptage(void)
{
	unsigned char L0;
	unsigned char L1;

	int Information = VALEUR_MINIMALE_COMPTAGE;

	L1 = EERead(ADRESSE_COMPTAGE);

	if(L1 == 0xFF)
	{
		Information = VALEUR_MINIMALE_COMPTAGE;
	}
	else
	{
		L0 = EERead(ADRESSE_COMPTAGE + 1);

		Information = L1;
 		Information <<= 8;
		Information |= (0x00FF & L0);
	}

	return Information;
}


unsigned char RecupererFonctionPrecedente(void)
{
	unsigned char Valeur = 0;

	Valeur = EERead(ADRESSE_FONCTIONNEMENT);

	if((Valeur != THERMOMETRE) && (Valeur != COMPTEUR))
	{
		EEWrite(ADRESSE_FONCTIONNEMENT, THERMOMETRE);

		Valeur = THERMOMETRE;
	}

	return Valeur;
}
