


#include "h/Thermometre.h"
#include "h/I2C.h"
#include "h/MemorisationsEEPROM.h"
#include "h/Comptages.h"
#include "h/Affichages.h"
#include "h/Utilitaires.h"
#include "h/Parametres.h"



extern unsigned char g_Affichages[8];



int g_Minimale1 = 0;
int g_Maximale1 = 0;

int g_Minimale2 = 0;
int g_Maximale2 = 0;



void ConfigurerUnCapteur(unsigned char Adresse)
{
	Write16court(Adresse, 0x01, 0x78);
	Write16nouvelle(Adresse, 0x01, 0x60, 0x00);
	Write16nouvelle(Adresse, 0x02, 0xFF, 0xC0);
	Write16nouvelle(Adresse, 0x03, 0x00, 0x30);
}


void MaximumMinimum1(unsigned char C1, unsigned char C2)
{
	int TemperatureMesuree;

	TemperatureMesuree = OctetsVersEntier(C1, C2);

	if(TemperatureMesuree < g_Minimale1)
	{
		g_Minimale1 = TemperatureMesuree;
	}
	if(TemperatureMesuree > g_Maximale1)
	{
		g_Maximale1 = TemperatureMesuree;
	}
}

void MaximumMinimum2(unsigned char C1, unsigned char C2)
{
	int TemperatureMesuree;

	TemperatureMesuree = OctetsVersEntier(C1, C2);

	if(TemperatureMesuree < g_Minimale2)
	{
		g_Minimale2 = TemperatureMesuree;
	}
	if(TemperatureMesuree > g_Maximale2)
	{
		g_Maximale2 = TemperatureMesuree;
	}
}

void ReinitialiserExtremes1(void)
{
	unsigned char T0;
	unsigned char T1;

	if(LireTemperature1(&T1, &T0) == 0x00)
	{
		g_Affichages[0] = ConvertirPourAffichage('E');
		g_Affichages[1] = 0x00;
		g_Affichages[2] = 0x00;
		g_Affichages[3] = 0x00;
	}

	g_Minimale1 = OctetsVersEntier(T1, T0);	/* Enregistrement de la temprature intrieure minimale. */

	g_Maximale1 = g_Minimale1;	/* Enregistrement de la temprature intrieure maximale. */
}

void ReinitialiserExtremes2(void)
{
	unsigned char T0;
	unsigned char T1;

	if(LireTemperature2(&T1, &T0) == 0x00)
	{
		g_Affichages[4] = ConvertirPourAffichage('E');
		g_Affichages[5] = 0x00;
		g_Affichages[6] = 0x00;
		g_Affichages[7] = 0x00;
	}

	g_Minimale2 = OctetsVersEntier(T1, T0);	/* Enregistrement de la temprature extrieure minimale. */

	g_Maximale2 = g_Minimale2;	/* Enregistrement de la temprature extrieure maximale. */
}


